[![KendoReact NPM Banner](https://raw.githubusercontent.com/telerik/kendo-react/master/images/kendoreact-github-banner.png)](https://www.telerik.com/kendo-react-ui/components/free?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid&utm_content=banner)

# KendoReact Data Grid (Table) Component for React

> **Important**
>
> -   This package is а part of [KendoReact](https://www.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;an enterprise-grade UI library with 120+ free and premium components.
> -   This is a free React Data Grid (Table) component with premium features. To use the premium features of the KendoReact Data Grid (Table), you will need to [purchase a license](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid) or register for a [free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid). You can use the free features even in production, no sign-up or license required.
> -   If you're looking for more free React components, check out [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free).
> -   If you have an active license, visit the [KendoReact My License page](https://www.telerik.com/kendo-react-ui/components/my-license/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid) to learn how to configure your KendoReact licensing.
> -   Installing and working with this package indicates that you [accept the KendoReact License Agreement](https://www.telerik.com/purchase/license-agreement/progress-kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid).
> -   The [30-day free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid) gives you access to all KendoReact components and their full functionality. Additionally, for the period of your trial, you can use our legendary technical support provided directly by the KendoReact dev team!

[The React Data Grid (Table)](https://www.telerik.com/kendo-react-ui/grid), part of KendoReact, provides 100+ ready-to-use free and premium data grid features covering everything from paging, sorting, filtering, editing, and grouping to row and column virtualization, export to PDF and Excel.

How to start:

```sh
npm i @progress/kendo-react-grid
```

## React Data Grid

> This is a **free React component** with premium features such as RSC mode, server-side capabilities, advanced filtering and grouping, and others. The free feature set does not require any sign-up or license. The premium features require a commercial license or an active trial license.

The KendoReact Grid component is built on React from the ground up by developers with 19+ years of experience in making enterprise-ready components. This results in a React data grid that delivers lightning fast performance and is highly customizable.

The Grid is fully accessible and delivers support for WCAG 2.1, Section 508, and WAI-ARIA a11y standards.

Among the many features which the KendoReact Data Grid delivers are:

-   [Paging (premium)](https://www.telerik.com/kendo-react-ui/components/grid/paging/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;You also have the option to add a pager for easier navigation.
-   [Sorting](https://www.telerik.com/kendo-react-ui/components/grid/sorting/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;Apart from the sorting and unsorting options of multiple columns, you can also pre-sort the data records of the Grid.
    -   Single-column sorting (free)
    -   Multi-column sorting (premium)
-   [Filtering](https://www.telerik.com/kendo-react-ui/components/grid/filtering/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;Including additional cell customization options.
    -   Quick filter (free)
    -   Row and header filtering (free)
    -   Column menu filter (premium)
    -   External filter (premium)
    -   Custom filter operations (premium)
    -   Multi-column filtering (premium)
-   [Grouping (premium)](https://www.telerik.com/kendo-react-ui/components/grid/grouping/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-native)&mdash;Out of the box, you can apply dynamic grouping to the data Grid records, set grouping by aggregate values, and in the same way as with the sorting functionality, pre-group the data.
-   [Editing](https://www.telerik.com/kendo-react-ui/components/grid/editing/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;Depending on your users' requirements, you can opt for the inline or the in-cell edit modes, provide editing from an external form or Redux Form and further customize the Grid.
    -   In-cell editing (free)
    -   In-cell editing of all celss (free)
    -   Inline (row) editing (premium)
    -   Inline editing with custom editors (premium)
    -   Inline editing with external form (premium)
-   [Row selection](https://www.telerik.com/kendo-react-ui/components/grid/selection/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;You can additionally configure it by enabling or disabling the checkbox and row selection options.
    -   Single row selection (free)
    -   Multiple row selection (premium)
-   [Export to PDF (premium)](https://www.telerik.com/kendo-react-ui/components/grid/pdf-export/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid) and [Excel](https://www.telerik.com/kendo-react-ui/components/grid/excel-export/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;When implementing the Grid export to PDF, you can set the fonts, the exact portion and layout of the exported content, also customize the columns and other specifics of the output result. When exporting to Excel, you can export specific data and customize the exported columns.
-   [Custom renderer](https://www.telerik.com/kendo-react-ui/components/grid/styling/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;Based on a value, you can also use conditional formatting (highlight a data table cell).
-   [Locked columns (premium)](https://www.telerik.com/kendo-react-ui/components/grid/columns/locked/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;When your Grid has to display large amounts of data, the frozen columns feature enables you to lock any of the Grid columns by just setting the locked column property.
-   [Virtualization](https://www.telerik.com/kendo-react-ui/components/grid/scroll-modes/virtual/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;The Grid supports virtualization of both column and row data. This feature boosts the performance of the component when displaying large data tables as it dynamically renders only a portion of the rows and the columns.
    -   Numeric pager with dropdown (free)
    -   Column virtualization (free)
    -   Row virtualization (premium)
-   [Column reordering (free)](https://www.telerik.com/kendo-react-ui/components/grid/columns/reordering/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;Reordering can be enabled for any column and is seamlessly integrated with the available Grid features, including locked columns.
-   [Column resizing (free)](https://www.telerik.com/kendo-react-ui/components/grid/columns/resizing/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;Resizing takes place real-time but can also be controlled from the outside.
-   [Detail templates (premium)](https://www.telerik.com/kendo-react-ui/components/grid/advanced-features/detail/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;The detail rows of the Grid provide additional details about a particular row of table data through expanding or collapsing its content.
-   [Globalization (free)](https://www.telerik.com/kendo-react-ui/components/grid/globalization/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;By using the available globalization options in KendoReact, you can translate the Grid messages by adapting them to specific culture locales.
-   [Theme support (free)](https://www.telerik.com/kendo-react-ui/components/styling/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)&mdash;The KendoReact Grid, as well as all 120+ components in the KendoReact suite, are styled in three polished themes (Bootstrap, Material, Fluent, and Default) and can be further customized to match your specific design guidelines.
-   [Server and hybrid data operations (premium)](https://www.telerik.com/kendo-react-ui/components/grid/rsc-mode)&mdash;The RCS mode of the KendoReact Grid is a modern, high-performance implementation built on top of the React Server Components (or RSC) architecture allowing you to perform server and hybrid data operations.

How to use the Data Grid component in your apps:

```tsx
import { Grid, GridColumn } from '@progress/kendo-react-grid';
...
/**
* Provide the data to populate the grid.
*/
<Grid data={data}>
    <GridColumn field="DataField1" />
    /**
    * Provide as many columns as needed. Every field must match an existing field in your data.
    */
</Grid>
```

## Support Options

For any issues you might encounter while working with the KendoReact Grid, use any of the available support channels:

-   Industry-leading technical support&mdash;KendoReact paid license holders and users with an active (free) trial license can take advantage of our outstanding customer support. To submit a ticket, use [the dedicated KendoReact support system](https://www.telerik.com/account/support-center/contact-us/technical-support?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid).
-   Product forums&mdash;The [KendoReact forums](https://www.telerik.com/forums/kendo-ui-react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid) are part of the free support you can get from the community and from the KendoReact team.
-   Feedback portal&mdash;The [KendoReact feedback portal](https://feedback.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid) is where you can request and vote for new features to be added.

## Resources

-   [Getting Started with KendoReact](https://www.telerik.com/kendo-react-ui/components/getting-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)
-   [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free)
-   [Get Started with the KendoReact Data Grid](https://www.telerik.com/kendo-react-ui/components/grid/get-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)
-   [API Reference of the KendoReact Data Grid](https://www.telerik.com/kendo-react-ui/components/grid/api/GridProps/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)
-   [KendoReact Roadmap](https://www.telerik.com/support/whats-new/kendo-react-ui/roadmap?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)
-   [Blogs](https://www.telerik.com/blogs/tag/kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)
-   [Demos, documentation, and component reference](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)
-   [KendoReact pricing and licensing](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)
-   [Changelog](https://www.telerik.com/kendo-react-ui/components/changelogs/ui-for-react/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-grid)

High-level component overview page:

-   [React Data Grid Component](https://www.telerik.com/kendo-react-ui/grid)

_Copyright © 2024 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved._

_Progress, Telerik, and certain product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries._
