/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const qe=require("react"),Oe=require("react-dom"),b=require("@progress/kendo-react-common"),Ae=require("../columnMenu/GridColumnMenuItem.js"),Pe=require("../columnMenu/GridColumnMenuItemContent.js"),Ne=require("../columnMenu/GridColumnMenuItemGroup.js"),Le=require("../utils/GridContext.js"),L=require("@progress/kendo-svg-icons"),d=require("../filterCommon.js"),I=require("@progress/kendo-react-buttons"),Ue=require("../columnMenu/GridColumnMenuFilterUI.js"),u=require("../messages/index.js"),Ve=require("@progress/kendo-react-intl"),C=require("../columnMenu/GridColumnMenuFilter.js"),_e=require("@progress/kendo-react-popup"),fe=require("@progress/kendo-react-indicators"),je=require("./adaptiveContext/GridToolbarAdaptiveContext.js"),ze=require("./adaptiveContent/GridAdaptiveToolbarFilter.js");function Ke(i){const l=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(i){for(const m in i)if(m!=="default"){const g=Object.getOwnPropertyDescriptor(i,m);Object.defineProperty(l,m,g.get?g:{enumerable:!0,get:()=>i[m]})}}return l.default=i,Object.freeze(l)}const t=Ke(qe),de=i=>{var te,re,oe,le,ne,ie,ae;const l=t.useContext(Le.GridContext),m=l.columnsRef;l.filterable;const g=l.defaultFilter,[y,E]=t.useState(!1),[me,k]=t.useState(!1),[F,S]=t.useState((m==null?void 0:m.map(e=>({column:e,expanded:!1})))||[]),[ge,U]=t.useState(!1),h=t.useRef(null),D=t.useRef(null),V=t.useRef(null),B=t.useRef(0),r=t.useRef(null),p=Ve.useLocalization(),pe=b.useDocument(h),_=t.useMemo(()=>(m==null?void 0:m.filter(e=>{var o;return(o=e.title||e.field)==null?void 0:o.toLowerCase()}))||[],[m]);t.useEffect(()=>{g&&k(!0)},[g]);const j=t.useCallback(e=>{const o=g&&g.filters.some(a=>a.field===e.field);return t.createElement(t.Fragment,null,e.title||e.field,o&&t.createElement("span",{className:"k-columnmenu-indicators"},t.createElement(b.SvgIcon,{key:1,icon:L.filterIcon})))},[g]),z=(e,o)=>{S(a=>(r.current=o,a.map(n=>n.column.field===o.field?{...n,expanded:!n.expanded}:{...n,expanded:!1}))),w(K()),U(!ge)},K=()=>{var o,a,n,c,se,ce;let e;if(r!=null&&r.current&&((o=r==null?void 0:r.current)!=null&&o.field)){const Te=d.getFilterType((a=r==null?void 0:r.current)==null?void 0:a.filter),v=d.getDefaultOperator(l.filterOperators,Te);e=C.filterGroupByField((n=r==null?void 0:r.current)==null?void 0:n.field,l.filter),e=e?{...e,filters:e.filters.map(N=>({...N}))}:{logic:"and",filters:[{field:(c=r==null?void 0:r.current)==null?void 0:c.field,operator:v,value:d.IsUnaryFilter(v)?null:void 0},{field:(se=r==null?void 0:r.current)==null?void 0:se.field,operator:v,value:d.IsUnaryFilter(v)?null:void 0}]},e.filters.filter(N=>{var ue;return N.field===((ue=r==null?void 0:r.current)==null?void 0:ue.field)}).length===1&&e.filters.splice(1,0,{field:(ce=r==null?void 0:r.current)==null?void 0:ce.field,operator:v})}return e},Fe=e=>{H(0,e)},he=e=>{H(1,e)},H=(e,o)=>{const a=f.filters.map((n,c)=>c===e?{...n,value:o.value||"",operator:o.operator||G[c].operator}:n);w({...f,filters:a})},[f,w]=t.useState(K()),s=f==null?void 0:f.filters,M=d.getFilterType((te=r==null?void 0:r.current)==null?void 0:te.filter),G=d.operatorMap(l.filterOperators[M],p),J=d.operatorMap(d.booleanFilterValues,p),ve={field:(re=r==null?void 0:r.current)==null?void 0:re.field,value:s==null?void 0:s[0].value,operator:s==null?void 0:s[0].operator,operators:G,booleanValues:J,onChange:Fe,filterType:M},be={field:(oe=r==null?void 0:r.current)==null?void 0:oe.field,value:s==null?void 0:s[1].value,operator:s==null?void 0:s[1].operator,operators:G,booleanValues:J,onChange:he,filterType:M},Ce=e=>{let o=e.target.value;e.target.tagName==="SPAN"&&(o=e.target.parentElement.value),w({...f,logic:o})},Q=f==null?void 0:f.logic,W=d.operatorMap(d.filterLogicList,p),T={value:W.find(e=>e.operator===(Q===null?"":Q)),onChange:Ce,data:W},Ee=i.hideSecondFilter!==void 0?i.hideSecondFilter:d.defaultHideSecondFilter[M],q=i.filterUI,O={firstFilterProps:ve,secondFilterProps:be,logicData:T.data,logicValue:T.value,onLogicChange:T.onChange,hideSecondFilter:Ee},X=()=>({...f,filters:f==null?void 0:f.filters.filter(e=>e.value!==void 0&&e.value!==null&&e.value!==""||e.value===null&&e.operator)}),A=((ne=(le=X())==null?void 0:le.filters)==null?void 0:ne.length)!==0||d.IsUnaryFilter(s==null?void 0:s[0].operator)||d.IsUnaryFilter(s==null?void 0:s[1].operator),Y=e=>{if(e.preventDefault(),!l.filterChange)return;const o=C.rootFilterOrDefault(l.filter),a={...o,filters:o.filters.filter(n=>{var c;return n.field!==((c=r==null?void 0:r.current)==null?void 0:c.field)})};A&&a.filters.push(X()),l.filterChange(a,e),k(!0),E(!1)},Z=e=>{if(e.preventDefault(),!l.filterChange)return;const o=C.rootFilterOrDefault(l.filter),a=o.filters.filter(n=>{var c;return n.field!==((c=r==null?void 0:r.current)==null?void 0:c.field)});a.length===0?l.filterChange(null,e):l.filterChange({...o,filters:a},e),i.onCloseMenu&&i.onCloseMenu(),k(!1),S(n=>n.map(c=>({...c,expanded:!1})))},ke=()=>{U(!1)},Me=e=>{e.preventDefault(),E(!y)},Ie=e=>{!e.isAnchorClicked&&E(!1)},P=t.useMemo(()=>i.show!==void 0?i.show:y,[i.show,y]),ye=e=>{const o=b.getActiveElement(document);clearTimeout(B.current),B.current=window.setTimeout(()=>{!l.mobileMode&&o&&e.relatedTarget!==h.current&&D.current&&!D.current.contains(o)&&$()})},$=()=>{var e;i.onCloseMenu&&i.onCloseMenu(),E(!1),h.current&&((e=h.current.element)==null||e.focus())},Se=()=>{clearTimeout(B.current)},{onFocus:De,onBlur:Be}=b.useAsyncFocusBlur({onFocus:e=>Se(),onBlur:e=>ye(e)}),we=e=>{var o;(o=V.current)==null||o.triggerMouseEvent(e)},Ge=e=>{var o;(o=V.current)==null||o.triggerKeyboardEvent(e)},x=t.useCallback(e=>{if(e.preventDefault(),!l.filterChange)return;const o=C.rootFilterOrDefault(l.filter),a=o.filters.filter(()=>!1);a.length===0?l.filterChange(null,e):l.filterChange({...o,filters:a},e),k(!1),S(n=>n.map(c=>({...c,expanded:!1})))},[l,C.rootFilterOrDefault]),R=t.createElement(I.Button,{ref:h,togglable:!0,selected:P,svgIcon:i.svgIcon?i.svgIcon:i.icon?void 0:L.filterIcon,icon:i.icon,size:l.mobileMode?"large":"medium",className:b.classNames("k-toolbar-button",{"k-icon-button":l.mobileMode}),title:p.toLanguageString(u.toolbarFilter,u.messages[u.toolbarFilter]),onClick:Me},!l.mobileMode&&p.toLanguageString(u.toolbarFilter,u.messages[u.toolbarFilter])),ee=t.createElement(t.Fragment,null,_.map(e=>{var o,a;return e.filterable&&t.createElement(Ne.GridColumnMenuItemGroup,{key:e.id},t.createElement("div",{className:"k-expander"},t.createElement(Ae.GridColumnMenuItem,{title:j(e),expandable:!0,expanded:!!((o=F==null?void 0:F.find(n=>n.column.field===e.field))!=null&&o.expanded),onClick:n=>z(n,e)})),t.createElement(Pe.GridColumnMenuItemContent,{show:!!((a=F==null?void 0:F.find(n=>n.column.field===e.field))!=null&&a.expanded)},t.createElement("form",{className:"k-filter-menu",onSubmit:Y,onReset:Z},t.createElement("div",{className:"k-filter-menu-container"},q?t.createElement(q,{...O}):t.createElement(Ue.GridColumnMenuFilterUI,{...O}),t.createElement("div",{className:"k-actions k-actions-stretched"},t.createElement(I.Button,{themeColor:"primary",disabled:!A},p.toLanguageString(u.filterSubmitButton,u.messages[u.filterSubmitButton])),t.createElement(I.Button,{type:"reset"},p.toLanguageString(u.filterClearButton,u.messages[u.filterClearButton])))))))}),t.createElement("div",{className:"k-actions k-actions-stretched k-actions-horizontal k-column-menu-footer"},t.createElement(I.Button,{svgIcon:L.filterClearIcon,onClick:x},p.toLanguageString(u.filterClearAllButton,u.messages[u.filterClearAllButton]))));return t.createElement(t.Fragment,null,me?t.createElement(fe.BadgeContainer,null,R,t.createElement(fe.Badge,{themeColor:"primary"})):R,l.mobileMode?t.createElement(je.GridToolbarAdaptiveProvider,null,Oe.createPortal(t.createElement(ze.GridAdaptiveToolbarFilter,{filtered:_,computedShow:P,expandState:F,FilterUI:q,filterUIProps:O,isFilterValid:A,renderTitle:j,onBackView:ke,clear:Z,submit:Y,onClose:$,onFilterExpand:z,handleClearAllFilters:x},ee),(ie=pe())==null?void 0:ie.body)):t.createElement(_e.Popup,{anchor:(ae=h.current)==null?void 0:ae.element,show:P,popupClass:"k-grid-columnmenu-popup",onMouseDownOutside:Ie},t.createElement("div",{ref:D,onBlur:Be,onFocus:De,onMouseDown:we,onKeyDown:Ge,className:"k-column-menu k-column-menu-md"},ee)))};de.displayName="KendoReactGridToolbarFilter";exports.GridToolbarFilter=de;
